Index: MLXMANIFEST
===================================================================
--- MLXMANIFEST	(revision 166)
+++ MLXMANIFEST	(revision 179)
@@ -3,5 +3,5 @@
 library/encodings/euc_jis_2004.pyc	1694	e12bbd059d4fd595cf4be5440ab439c2
 library/fnmatch.pyc	3414	4d50000f78e903598af06ef1c5cfb3ef
-library/gtk/_gtk.pyc	549	cce831fbbce661780e4aa4aee4005355
+library/gtk/_gtk.pyc	549	bd5093e815e6d1b79f5514755cbd1c7b
 library/encodings/cp858.pyc	7591	02054a0b8e91b9758826eb70cddf096f
 library/encodings/cp1254.pyc	2678	17ff2ac86f90886d5c73ed789f0499f3
@@ -9,8 +9,11 @@
 library/posixpath.pyc	10734	d694316c239784c444b252c801c97efa
 library/encodings/gbk.pyc	1622	71c1e7fe25116114241829a60e57c5f4
+sounds/speed.mp3	26331	3d64da0eea9f48fa73be82d385354bf6
 library/encodings/cp932.pyc	1638	e060301989634a7fb30ded375011cb09
+sounds/737taxi.mp3	157362	846c403e5cb660be53c8b6da16b68234
 library/unittest/signals.pyc	2126	d574469ae3f8e3c3c6054c48e8ff6fe1
+sounds/notam.mp3	195604	9c5edf885a2ba68484a9554a1cd22c47
 library/pdb.pyc	41336	cca4477d622e897335b3f0cecb667ff4
-runmlx.exe	64000	488633e152c81c000e315cd0d74d6474
+runmlx.exe	64000	93da559ab26e081a7e0956e23d8154ae
 library/xml/sax/xmlreader.pyc	17862	0362ded7016d21cdd85aea1170ebdda1
 library/encodings/latin_1.pyc	2111	52427573ccbfd06220b67d5a9dd1376e
@@ -36,4 +39,5 @@
 library/encodings/cp737.pyc	8102	40e61988748e4ca1742a2bad43949f4e
 library/encodings/cp500.pyc	2639	bb122a6e1384530e1b2efb14cf999239
+sounds/TaxiAfterLand.mp3	155481	ded1908d2e7bf2ee2cbf445bb44cf756
 library/urlparse.pyc	13222	cca8581f4f4fa9067ccc880f049a6032
 library/encodings/cp865.pyc	7868	7d40a7ba053ac23339218be8799e5397
@@ -51,4 +55,5 @@
 library/email/message.pyc	27764	493826f529d17f5a21080a4c98b49369
 library/unittest/__init__.pyc	2945	3b9d3992b823bd7bc391d8b1bb434310
+sounds/sikoly.mp3	126222	b0bb88361b253cd21bfd3706524f4aec
 library/xml/sax/expatreader.pyc	13563	4f64c0efb2f1f8dbba84cdb5c6036f2d
 library/encodings/iso8859_14.pyc	2714	b9baeb3f59da8a2137db576b2e434feb
@@ -58,6 +63,6 @@
 library/encodings/koi8_r.pyc	2700	fff1b35002b9e938b7ea6fd0fbe824ae
 library/mlx/gui/statusbar.pyc	4616	2909310114db08ca8d3162e70ef22519
-library/mlx/const.pyc	4972	8b05e5b96077ed4c99eebd228f48db69
-library/mlx/fsuipc.pyc	53402	5c12463c240c8e90844490a9ff850168
+library/mlx/const.pyc	5949	53bfc407923ea2f05e6f3179d22927e8
+library/mlx/fsuipc.pyc	59779	676991ccf9572899c32a327b70281d33
 library/encodings/punycode.pyc	7570	335ff94e207934ae64e6f5fc07a5cacc
 library/encodings/shift_jisx0213.pyc	1710	1ec0383aafb1dcadb5f9b6afff16eb7f
@@ -65,4 +70,5 @@
 library/encodings/idna.pyc	6124	6d67198be2b194c4c0acf48e2f1473ac
 library/encodings/iso8859_8.pyc	2717	f3ad6ce58cfac9e3ca86cf5c2fef092b
+sounds/767taxi.mp3	160496	4cb43cda6e1214fbe15328a716827345
 library/encodings/utf_16.pyc	4808	45343ba87ff1675cd72f656555193d29
 library/httplib.pyc	35251	2ac8119676b4b02ed78fd020ea423de5
@@ -78,4 +84,5 @@
 library/gettext.pyc	14675	606ad2e00535dd0f4fee5bd8d8562b29
 library/random.pyc	24831	54b2048974a5c98912276ffa5dc637a9
+library/mlx/soundsched.pyc	9162	1d1c69f86f673613723641cb42364944
 library/mlx/logger.pyc	4911	6e05091ca671441f5e56a2f8afff02ed
 library/encodings/string_escape.pyc	1907	5856af6d4b4bbbe84b0595434afe8d34
@@ -95,5 +102,5 @@
 library/encodings/iso2022_jp_2004.pyc	1723	66376e788f3819e781897268c1100986
 library/encodings/cp866.pyc	8103	f36418dcf93b17b3ced63bd544f44159
-library/gio/_gio.pyc	549	014ddc5612d5ab5e06a303cfa0bcf0e9
+library/gio/_gio.pyc	549	0805050149840335900131253ff39f19
 library/encodings/cp437.pyc	7874	63f1278c0a66129c6fb4f504d6b61b66
 library/mimetools.pyc	7837	c9accd6ef795bf71c90630be0161cadc
@@ -116,5 +123,5 @@
 library/unittest/case.pyc	37758	1d2235e74c246b562c5c00ddf73c621a
 library/encodings/euc_jp.pyc	1646	c0d60e6d08161643bd7dbe651063f334
-library/mlx/acft.pyc	26446	e96a0c5d39140d7b89d67adae465ec33
+library/mlx/acft.pyc	26451	954fb00cbe315b51a58a01331cc532ce
 library/gobject._gobject.pyd	113152	3d05dd191361f83aa247b62c700fa04e
 library/bisect.pyc	2971	ad8ce3e265b404ed3971b842106f8179
@@ -123,5 +130,5 @@
 library/encodings/cp864.pyc	7999	ca90afae086cb6b8f69b8419cc3cd1cb
 library/pyexpat.pyd	152576	5a82e9ec95005aca6130751e5b961cc3
-library/pyexpat.pyc	546	28db9f4e93d106aa021b40423032f06b
+library/pyexpat.pyc	546	09c1bffc5ce06ccca8430918e5971de7
 library/unittest/loader.pyc	10884	591a785be23fba35582ce33bdd3d7acd
 library/ftplib.pyc	32043	5a1925388a0874e459aed6891f4cf0c1
@@ -130,14 +137,14 @@
 library/unittest/suite.pyc	9838	bf2c79bd4a6b6032f1ea53fa4908748f
 library/encodings/mac_arabic.pyc	7824	820deef79b02e1f7e52eb18e9be655bf
-library/mlx/gui/prefs.pyc	13053	0d5dbe8afbb8fab7b2be1840781e8db2
+library/mlx/gui/prefs.pyc	23036	e658c809a306db280a5e1539ddd192e5
 library/encodings/tis_620.pyc	2748	5969b4db4f967b11ae7992cdfbf5890e
 library/encodings/cp855.pyc	8071	0a4259ba854c24186f2ce61d85883b4a
 Microsoft.VC90.CRT/msvcr90.dll	655872	e7d91d008fe76423962b91c43c88e4eb
 sounds/ding.wav	80856	18e639792d3767436ac6955eb60e4f54
-library/mlx/checks.pyc	41428	089e6f6ac595c246520fa5c2f9750f66
+library/mlx/checks.pyc	41608	1d43e86f3d90e6d3019840e4a9f42cf9
 library/libpangowin32-1.0-0.dll	108945	d07f128828225b7cc38e9e590eb3ba8a
 library/gobject/constants.pyc	1957	2e9cdc605e7c449ef4fc23f56128acec
 library/ssl.pyc	13785	d90c880699ecbedb3182f556b9733868
-library/mlx/sound.pyc	5575	fce8f0388061974c7be42548bb0ed53b
+library/mlx/sound.pyc	6252	5bad6ec8ed6306876831dd0b320c8f1e
 library/encodings/euc_jisx0213.pyc	1694	88f34b9922eddbe5e1f3c77fd89e86f9
 w9xpopen.exe	49664	e6895233ad1e6f3dcdd04c7c26b0e7c0
@@ -149,4 +156,5 @@
 library/heapq.pyc	13109	20df4990fffba06bbdda995ce7466caa
 library/sre_compile.pyc	10792	c58f94fbee661f3bb0c59ecc13c0416e
+sounds/notify.wav	119384	108025b17f67e61946df5d7fbf713cdb
 library/encodings/iso8859_9.pyc	2678	88880e046738ebd2012c8034416a9adf
 library/encodings/mac_greek.pyc	2699	770cdf4f35a081a8ce71e776e6ecd804
@@ -156,6 +164,6 @@
 library/email/iterators.pyc	2266	b8a0df35815bc00be1ed8ece42aac537
 library/encodings/iso8859_10.pyc	2693	5e6cc8f721486ddbc1c99da285e13191
-library/mlx/config.pyc	12010	7a138f5b96c513912e8e0686f5c5fbaa
-library/atk.pyc	534	fe3e307a78a9cc4bce684d7bdf816dff
+library/mlx/config.pyc	19351	80b6d2f555bc02fe0c2c45f09ab17652
+library/atk.pyc	534	a7bf65f4b40a65a3c906c87692b9c744
 library/gio._gio.pyd	263168	acb8c95fdc391079bebdf7d8685b0dbc
 library/encodings/cp861.pyc	7868	c97a8970ce4d9f40cbafbea6576fbdca
@@ -165,7 +173,9 @@
 library/cairo._cairo.pyd	69632	46d708899832abc0123c4e9cb4f61d5d
 library/encodings/raw_unicode_escape.pyc	2048	8138045029da04bf45204ab756d1bcd4
+sounds/TOD.mp3	174707	92176d53d948fbfebd08c011b063179a
 library/difflib.pyc	60869	38d2e1340b64e22d7b1fed90a57fb83a
 library/gtk/deprecation.pyc	3104	2e6c9eef82dfa8aa3beb05abd3e274a4
 Microsoft.VC90.CRT/msvcm90.dll	224768	4a8bc195abdc93f0db5dab7f5093c52f
+sounds/board.mp3	296751	bbacc6eabce97cbae49b4157ece7b8fe
 library/encodings/iso8859_7.pyc	2686	db390f1961c1fd4181e351c330816ecd
 library/xml/__init__.pyc	1058	8f77f254e8c6db7a3b6d9930a686d787
@@ -174,7 +184,7 @@
 library/encodings/iso8859_6.pyc	2723	c8f9aa14a6a2ebf05d977317114bc65d
 library/libpango-1.0-0.dll	333729	5a14efd93ee27cfe960220fe4a904911
-library/mlx/gui/gui.pyc	36364	2050500c35abdb515d17daf894d29320
+library/mlx/gui/gui.pyc	38415	e3b5616326e69b2518fd01052353bed2
 library/stat.pyc	2503	d3b6dc7a54e705219f04d0be75a212de
-library/gobject/_gobject.pyc	573	891881fc921b55eb6436b850d5bf668a
+library/gobject/_gobject.pyc	573	59760b090bb2c647403e710280015a26
 library/encodings/utf_7.pyc	1747	2beeb059236527197d6c640396476ce8
 library/atexit.pyc	2083	595a09be339c73c3c02e378d99325d2a
@@ -184,8 +194,8 @@
 library/encodings/iso8859_1.pyc	2678	f09ec3b7f6a348cbd7f7286b60572bd0
 library/pangocairo.pyd	17920	5fc69a7d29a6d3127710c64de440daa4
-library/pangocairo.pyc	555	f23a6733ab8c9132c1c6791714240df2
+library/pangocairo.pyc	555	f3604d34848da460654e656849501213
 library/sre.pyc	499	92bb633daa0bab6550ec0e3677673b5b
 library/tokenize.pyc	13565	354d02cd79df187a28c1851a1e3bad96
-library/mlx/gui/flight.pyc	85418	86f3c4ba458413deabd618aa67421374
+library/mlx/gui/flight.pyc	85516	b379ab50932898e443382553c372476b
 library/lib/gtk-2.0/2.10.0/engines/libwimp.dll	97984	a5bbbe46e1363aba9020a76f2d58e9d6
 library/email/quoprimime.pyc	8590	f6c7a8ad81d44037dd074f4871053dab
@@ -195,5 +205,5 @@
 library/gtk._gtk.pyd	1882624	bbb1d1e41bbebc6abf69bed719d50497
 library/_hashlib.pyd	287232	a1a18de0644f481749fcbcf26005eeaf
-library/_hashlib.pyc	549	b0f9228e2299a7272830effaa43a4377
+library/_hashlib.pyc	549	65d6a9a19f59d40c4a91c9291c5c331b
 library/copy.pyc	11674	30d1745c5e38ab170f8a0486fbebf305
 library/unittest/result.pyc	7444	aefbb3cc79c0ff17787ce84faed7f5e8
@@ -201,5 +211,5 @@
 library/mlx/pirep.pyc	4830	6acde2b06cd512f9d9ad5a3f0a9c45bd
 library/traceback.pyc	11223	50ace5c2c6c040a923082442da94cd78
-library/mlx/flight.pyc	6977	a88b370d812feeb19635f77890cd3ce5
+library/mlx/flight.pyc	7980	ed2697886589b5b083f28d2650085376
 library/urllib2.pyc	43566	7eb57ea0dcd1086d1d9073a5cefb0903
 library/encodings/mac_farsi.pyc	2659	df751a61510129a25f7a43ae3aace4f7
@@ -207,5 +217,7 @@
 library/ctypes/__init__.pyc	18846	2bd183962453ae93d6887b303d3fd338
 library/mlx/acars.pyc	1690	06ac9e4ad5cc96b831a3c69868e6145a
-library/cairo/_cairo.pyc	561	6622b2b68a65815534f741644f28467a
+sounds/malev.mp3	201247	8a00666288f14a1666eb112223c140e0
+sounds/taps.mp3	16614	d4a019c7e9342ae329aee6932d6a43c3
+library/cairo/_cairo.pyc	561	ea670c94c697eee8874e31f2bf2e6dcc
 library/warnings.pyc	12666	9788b5f45765e8204e04c820f2711094
 library/encodings/iso2022_jp_1.pyc	1699	faed9d5747e982cec9fa8b3ad8e1de26
@@ -216,5 +228,5 @@
 library/encodings/charmap.pyc	3203	2358b8eb05c66e2a2826b5db6f214547
 library/libgdk-win32-2.0-0.dll	931390	a2b46daac3d4140efdf86429f7aea476
-library/mlx/gui/common.pyc	6168	7065e7de65fcc84b0616b39acc598802
+library/mlx/gui/common.pyc	7127	e432aaa3dea315efb8d3b98eeee209eb
 library/dummy_threading.pyc	1265	5ab5c897721aeb346b5bccb84066c5bd
 library/gtk/__init__.pyc	3025	9f6605bf84c6cbd3c20f1d37e58af969
@@ -223,16 +235,18 @@
 library/calendar.pyc	26136	6f2f18efc99d759f99b2935b9dc9dbb1
 library/encodings/aliases.pyc	8750	75c22196420d0157fec085d285947a71
+sounds/TOC.mp3	273032	fae1be2ad25c8b54806bd1d759919705
 library/bz2.pyd	76800	1ca9ececd2c84b80996fe632627f857f
 library/encodings/iso8859_16.pyc	2695	85e819a29dec2b601ce978dcd5a040fc
-library/bz2.pyc	534	2dacc1f67ce6f4b8bef18fddbc30c9de
+sounds/cpt_takeoff.mp3	8255	254edcf79b8b3752d1a7c191c57f615a
+library/bz2.pyc	534	2b5667114597864edb558c4eb8da3770
 library/email/utils.pyc	8840	a7be428df6fddee6121cfce55382d1f8
-library/_ssl.pyc	537	a5ad680df66cce9aa48b31a6396e6d12
+library/_ssl.pyc	537	af01c31cc31cfc4aaa2ab23fca3df447
 library/encodings/cp1250.pyc	2676	c92e287a2aa6a1c924df287d826aa3b7
 library/_ssl.pyd	720896	90826a140137efd0d806038828e16f8e
-library/pango.pyc	540	e3fcfc3d867e92c2c7416ef6dc684d58
+library/pango.pyc	540	6ab2c260ea5dcf9366e8dc838a08d724
 library/glib/__init__.pyc	187	d44c8c2772b263a36726ac0dcfc04b42
 library/pango.pyd	111616	c934763bdf125c3dc92b56db817001d4
 library/libgobject-2.0-0.dll	341594	356d697647a480562c4e2e921b13f8ed
-mlxupdate.exe	19456	e4a2240eacdc2647c90656899310c6f8
+mlxupdate.exe	19456	d70ecf3b37e8affa877bf09bbf3adda8
 library/email/errors.pyc	3229	cdb78ab237e195ad69f059128bc03b1d
 library/linecache.pyc	3091	666e6f81b0ea9a7637f8068493f738d5
@@ -248,7 +262,8 @@
 library/encodings/utf_32.pyc	5336	912103fef3db6edc29a35dd0cfb5c5b9
 library/ntpath.pyc	11407	533c9331a1b72cc80dd3f88145ba4466
+library/mlx/gui/checklist.pyc	9852	e1906b8bab3ead7a80ff8f810c461ae3
 library/encodings/mbcs.pyc	1883	2213911a7dd0deada6799b63e18b695b
 library/unicodedata.pyd	688128	c856c31a03dc892e4f2aee93d0bfee44
-library/unicodedata.pyc	558	4289806e666e46e891fceb60a20b894e
+library/unicodedata.pyc	558	296bfef725c79b893443fb69c9873e8d
 library/encodings/cp1256.pyc	2675	c1bf26ed9c9b5ee0eec495138993cffb
 library/email/base64mime.pyc	5221	c536d6f0c03f029bba77f15ef6ba3d99
@@ -286,7 +301,8 @@
 library/gio/__init__.pyc	809	bc9332556e93183a58be5c10cba18557
 library/weakref.pyc	13028	5d1c14275f47e8cf6d40bc6877fde976
-library/mlx/fs.pyc	8832	eab72e32441131b81492a19e3bfe4f0f
+library/mlx/fs.pyc	8904	c68bc25465af09e33622fc35b7c81be3
 library/nturl2path.pyc	1755	7835082f2dd6806f99cc25bed13ff7dc
 library/mimetypes.pyc	17806	927ce6a7079707aaee925e855ed23454
+sounds/F70taxi.mp3	154854	51332dc691d3519355f61ed06c959d8d
 library/encodings/cp1253.pyc	2689	52d4a723e9e86940701cb648b40ed884
 library/StringIO.pyc	11100	f4eb4a2bb3d6fb0af925681c5375c673
@@ -309,14 +325,14 @@
 library/encodings/koi8_u.pyc	2686	b7e5a52eaaaf6b340075b40dc7596f42
 library/atk.pyd	208384	ebe7f0929eac23a3205d17d69906e172
-library/_ctypes.pyc	546	3b2a84ea4d020180b585c738bf78cec1
+library/_ctypes.pyc	546	ea33e6b43690ebfe596cf09c89cea183
 library/mlx/update.pyc	16214	1927a43ac4580370198b6d2f091f835f
 library/subprocess.pyc	38648	c9f749db06dfc9fb32079de51d6efd01
 library/encodings/utf_16_le.pyc	1854	dfa68705c26fd303adfc7ce3322166f2
 library/_socket.pyd	38400	5d273be76603399e88cf57f2605004bf
-library/_socket.pyc	546	7b1bd8f25e4e763ce7a2163c657aa4d3
+library/_socket.pyc	546	2fb2587d0de7b81d733585e0a795d1b1
 library/encodings/hex_codec.pyc	3520	a8b8d5b7c8810379c7007bcbc253951c
 library/tempfile.pyc	18526	e2cc2d63c29e15f20ee9325e790643a3
-library/glib/_glib.pyc	555	b1fd18ba441a3ec8e55f93ebe9aa659a
-library/win32api.pyc	549	3228c4576e9659f1af7ff11114e2a90c
+library/glib/_glib.pyc	555	0dcd3b2b09ec3c4b5b674744e7370eb2
+library/win32api.pyc	549	2216e8bccbffdda081a7182eda587723
 library/encodings/iso8859_13.pyc	2696	f901ae0bbcfbb78f0c1783e89b2e2dc5
 library/zlib1.dll	100352	d90dad5eea33a178bac56fff2847d4c2
@@ -327,15 +343,15 @@
 library/encodings/mac_latin2.pyc	4717	564dbaf5c296a147203eb821dc2466ba
 library/mlx/__init__.pyc	103	029f80bd80f880e6ca70ef4ba46f7d06
-library/mlx/i18n.pyc	54950	876523432568278cc84d0a9a971db279
+library/mlx/i18n.pyc	62714	f453557c65bfb59815f5a1d66dc04031
 library/xml/sax/saxutils.pyc	12382	32ed045b3b520234ebea6a508a6569fe
 library/encodings/mac_turkish.pyc	2739	1682e228ddfd2e74e3ccaee0b65e7261
-library/mlx/pyuipc_sim.pyc	43607	eecadfd81467b977dc4a4ae2b05c487f
+library/mlx/pyuipc_sim.pyc	45022	04424e9b3d850628b864dff62fdf7460
 library/encodings/cp875.pyc	2636	c72faa5d1cb6105ae81c971448fea479
 library/socket.pyc	15488	35f8eb455d6d8df8e19826d1dd7193f2
-library/select.pyc	543	7c963d4085711e3cb6cb745bf936ef58
+library/select.pyc	543	a3d44ef5382da148517cc687b4cb34d9
 library/encodings/iso2022_jp.pyc	1683	40c2b92127f99452f84b250c2b4b2cda
 library/libgthread-2.0-0.dll	44287	7ad6f303082b382bff7bafbab246c61f
 library/select.pyd	11776	d90bf525f9f6c9c3aa6532fa6e569b4f
-library/pyuipc.pyc	543	2d50c10362e28900a8761a170f9c5061
+library/pyuipc.pyc	543	1474b318c0801f64535104fe01d2387a
 library/pyuipc.pyd	129220	58cdce7763687f456383c93fd3404d9f
 library/encodings/johab.pyc	1638	5346c11a863ffbcfb21aba8f1d2236b7