Index: src/mlx/checks.py
===================================================================
--- src/mlx/checks.py	(revision 170)
+++ src/mlx/checks.py	(revision 183)
@@ -549,5 +549,5 @@
                                       const.AIRCRAFT_T154]
         return (flight.stage!=const.STAGE_PARKING or \
-                not flight.options.fs2Crew) and \
+                not flight.config.usingFS2Crew) and \
                 not state.antiCollisionLightsOn and \
                 ((isTupolev and max(state.n1[1:])>5) or \
@@ -721,6 +721,6 @@
         limit = self.getLimit(flight, aircraft, state)
         if limit is not None:
-            if flight.options.compensation is not None:
-                limit += flight.options.compensation
+            #if flight.options.compensation is not None:
+            #    limit += flight.options.compensation
             return self.getWeight(state)>limit
 
Index: src/mlx/config.py
===================================================================
--- src/mlx/config.py	(revision 175)
+++ src/mlx/config.py	(revision 183)
@@ -125,4 +125,5 @@
         self._flareTimeFromFS = False
         self._syncFSTime = False
+        self._usingFS2Crew = False
 
         self._pirepDirectory = None
@@ -260,4 +261,16 @@
         if syncFSTime!=self._syncFSTime:
             self._syncFSTime = syncFSTime
+            self._modified = True
+
+    @property
+    def usingFS2Crew(self):
+        """Get whether the FS2Crew addon is being used."""
+        return self._usingFS2Crew
+
+    @usingFS2Crew.setter
+    def usingFS2Crew(self, usingFS2Crew):
+        """Set whether the FS2Crew addon is being used."""
+        if usingFS2Crew!=self._usingFS2Crew:
+            self._usingFS2Crew = usingFS2Crew
             self._modified = True
 
@@ -439,4 +452,7 @@
                                             "syncFSTime",
                                             False)
+        self._usingFS2Crew = self._getBoolean(config, "general",
+                                              "usingFS2Crew",
+                                              False)
         self._pirepDirectory = self._get(config, "general",
                                          "pirepDirectory", None)
@@ -499,4 +515,6 @@
         config.set("general", "syncFSTime",
                    "yes" if self._syncFSTime else "no")
+        config.set("general", "usingFS2Crew",
+                   "yes" if self._usingFS2Crew else "no")
 
         if self._pirepDirectory is not None:
Index: src/mlx/flight.py
===================================================================
--- src/mlx/flight.py	(revision 176)
+++ src/mlx/flight.py	(revision 183)
@@ -9,13 +9,4 @@
 
 import threading
-
-#---------------------------------------------------------------------------------------
-
-class Options(object):
-    """Various configuration options."""
-    def __init__(self):
-        """Construct the object with default values."""
-        self.fs2Crew = False
-        self.compensation = None        
 
 #---------------------------------------------------------------------------------------
@@ -39,6 +30,4 @@
         self.flareTimeFromFS = False
         self.entranceExam = False
-
-        self.options = Options()
 
         self.aircraftType = None
Index: src/mlx/gui/prefs.py
===================================================================
--- src/mlx/gui/prefs.py	(revision 174)
+++ src/mlx/gui/prefs.py	(revision 183)
@@ -228,4 +228,5 @@
         self._flareTimeFromFS.set_active(config.flareTimeFromFS)
         self._syncFSTime.set_active(config.syncFSTime)
+        self._usingFS2Crew.set_active(config.usingFS2Crew)
 
         pirepDirectory = config.pirepDirectory
@@ -267,4 +268,5 @@
         config.flareTimeFromFS = self._flareTimeFromFS.get_active()
         config.syncFSTime = self._syncFSTime.get_active()
+        config.usingFS2Crew = self._usingFS2Crew.get_active()
         config.pirepDirectory = text2unicode(self._pirepDirectory.get_text())
 
@@ -353,4 +355,9 @@
         self._syncFSTime.set_tooltip_text(xstr("prefs_syncFSTime_tooltip"))
         mainBox.pack_start(self._syncFSTime, False, False, 4)
+
+        self._usingFS2Crew = gtk.CheckButton(xstr("prefs_usingFS2Crew"))
+        self._usingFS2Crew.set_use_underline(True)
+        self._usingFS2Crew.set_tooltip_text(xstr("prefs_usingFS2Crew_tooltip"))
+        mainBox.pack_start(self._usingFS2Crew, False, False, 4)
 
         pirepBox = gtk.HBox()
Index: src/mlx/i18n.py
===================================================================
--- src/mlx/i18n.py	(revision 181)
+++ src/mlx/i18n.py	(revision 183)
@@ -631,6 +631,11 @@
                  "S_ynchronize the time in FS with the computer's clock")
         self.add("prefs_syncFSTime_tooltip",
-                 "If this is checked the flight simulator's internal clock "
+                 "If this is checked, the flight simulator's internal clock "
                  "will always be synchronized to the computer's clock.")
+        self.add("prefs_usingFS2Crew",
+                 "Using FS_2Crew")
+        self.add("prefs_usingFS2Crew_tooltip",
+                 "If this is checked, the logger will take into account, "
+                 "that you are using the FS2Crew addon.")
         self.add("prefs_pirepDirectory",
                  "_PIREP directory:")
@@ -1335,4 +1340,9 @@
                  "Ha ez bejelölöd, a szimulátor belső óráját a program "
                  "szinkronban tartja a számítógép órájával.")
+        self.add("prefs_usingFS2Crew",
+                 "Használom az FS_2Crew kiegészítőt")
+        self.add("prefs_usingFS2Crew_tooltip",
+                 "Ha ezt bejelölöd, a program figyelembe veszi, "
+                 "hogy az FS2Crew kiegészítőt használod.")
         self.add("prefs_pirepDirectory",
                  "_PIREP-ek könyvtára:")