Index: src/mlx/acft.py
===================================================================
--- src/mlx/acft.py	(revision 184)
+++ src/mlx/acft.py	(revision 191)
@@ -735,19 +735,20 @@
 #---------------------------------------------------------------------------------------
 
-_classes = { const.AIRCRAFT_B736 : B736,
-             const.AIRCRAFT_B737 : B737,
-             const.AIRCRAFT_B738 : B738,
-             const.AIRCRAFT_B733 : B733,
-             const.AIRCRAFT_B734 : B734,
-             const.AIRCRAFT_B735 : B735,
-             const.AIRCRAFT_DH8D : DH8D,
-             const.AIRCRAFT_B762 : B762,
-             const.AIRCRAFT_B763 : B763,
-             const.AIRCRAFT_CRJ2 : CRJ2,
-             const.AIRCRAFT_F70 : F70,
-             const.AIRCRAFT_DC3 : DC3,
-             const.AIRCRAFT_T134 : T134,
-             const.AIRCRAFT_T154 : T154,
-             const.AIRCRAFT_YK40 : YK40 }
-
-#---------------------------------------------------------------------------------------
+_classes = { const.AIRCRAFT_B736  : B736,
+             const.AIRCRAFT_B737  : B737,
+             const.AIRCRAFT_B738  : B738,
+             const.AIRCRAFT_B738C : B738Charter,
+             const.AIRCRAFT_B733  : B733,
+             const.AIRCRAFT_B734  : B734,
+             const.AIRCRAFT_B735  : B735,
+             const.AIRCRAFT_DH8D  : DH8D,
+             const.AIRCRAFT_B762  : B762,
+             const.AIRCRAFT_B763  : B763,
+             const.AIRCRAFT_CRJ2  : CRJ2,
+             const.AIRCRAFT_F70   : F70,
+             const.AIRCRAFT_DC3   : DC3,
+             const.AIRCRAFT_T134  : T134,
+             const.AIRCRAFT_T154  : T154,
+             const.AIRCRAFT_YK40  : YK40 }
+
+#---------------------------------------------------------------------------------------
Index: src/mlx/checks.py
===================================================================
--- src/mlx/checks.py	(revision 184)
+++ src/mlx/checks.py	(revision 191)
@@ -831,5 +831,5 @@
     def isCondition(self, flight, aircraft, oldState, state):
         """Check if the fault condition holds."""
-        return not flight.entranceExam and \
+       return not flight.entranceExam and \
                flight.stage==const.STAGE_PUSHANDTAXI and \
                PayloadChecker.isZFWFaulty(state.zfw, flight.zfw)
Index: src/mlx/const.py
===================================================================
--- src/mlx/const.py	(revision 187)
+++ src/mlx/const.py	(revision 191)
@@ -41,4 +41,7 @@
 # Aircraft type: Boeing 737-800
 AIRCRAFT_B738 = 3
+
+# Aircraft type: Boeing 737-800 (charter configuration)
+AIRCRAFT_B738C = 16
 
 # Aircraft type: Boeing 737-300
@@ -83,5 +86,6 @@
 # The order is mostly from most recent to oldest considering
 # Malev's history
-aircraftTypes = [AIRCRAFT_B736, AIRCRAFT_B737, AIRCRAFT_B738,
+aircraftTypes = [AIRCRAFT_B736, AIRCRAFT_B737,
+                 AIRCRAFT_B738, AIRCRAFT_B738C,
                  AIRCRAFT_DH8D,
                  AIRCRAFT_F70, AIRCRAFT_CRJ2,
@@ -93,20 +97,22 @@
 #-------------------------------------------------------------------------------
 
-# A mapping of aircraft types to their ICAO codes
-icaoCodes = { AIRCRAFT_B736 : "B736",
-              AIRCRAFT_B737 : "B737",
-              AIRCRAFT_B738 : "B738",
-              AIRCRAFT_B733 : "B733",
-              AIRCRAFT_B734 : "B734",
-              AIRCRAFT_B735 : "B735",
-              AIRCRAFT_DH8D : "DH8D",
-              AIRCRAFT_B762 : "B762",
-              AIRCRAFT_B763 : "B763",
-              AIRCRAFT_CRJ2 : "CRJ2",
-              AIRCRAFT_F70  : "F70",
-              AIRCRAFT_DC3  : "DC3",
-              AIRCRAFT_T134 : "T134",
-              AIRCRAFT_T154 : "T154",
-              AIRCRAFT_YK40 : "YK40" }
+# A mapping of aircraft types to their 'internal' ICAO codes (which are
+# the same as the real ICAO codes, except in a few cases)
+icaoCodes = { AIRCRAFT_B736  : "B736",
+              AIRCRAFT_B737  : "B737",
+              AIRCRAFT_B738  : "B738",
+              AIRCRAFT_B738C : "B738C",
+              AIRCRAFT_B733  : "B733",
+              AIRCRAFT_B734  : "B734",
+              AIRCRAFT_B735  : "B735",
+              AIRCRAFT_DH8D  : "DH8D",
+              AIRCRAFT_B762  : "B762",
+              AIRCRAFT_B763  : "B763",
+              AIRCRAFT_CRJ2  : "CRJ2",
+              AIRCRAFT_F70   : "F70",
+              AIRCRAFT_DC3   : "DC3",
+              AIRCRAFT_T134  : "T134",
+              AIRCRAFT_T154  : "T154",
+              AIRCRAFT_YK40  : "YK40" }
 
 #-------------------------------------------------------------------------------
Index: src/mlx/fsuipc.py
===================================================================
--- src/mlx/fsuipc.py	(revision 168)
+++ src/mlx/fsuipc.py	(revision 191)
@@ -1450,5 +1450,6 @@
         return aircraft.type in [const.AIRCRAFT_B736,
                                  const.AIRCRAFT_B737,
-                                 const.AIRCRAFT_B738] and \
+                                 const.AIRCRAFT_B738,
+                                 const.AIRCRAFT_B738C] and \
             (name.find("PMDG")!=-1 or airPath.find("PMDG")!=-1) and \
             (name.find("737")!=-1 or airPath.find("737")!=-1) and \
@@ -1648,19 +1649,20 @@
 #------------------------------------------------------------------------------
 
-_genericModels = { const.AIRCRAFT_B736 : B737Model,
-                   const.AIRCRAFT_B737 : B737Model,
-                   const.AIRCRAFT_B738 : B737Model,
-                   const.AIRCRAFT_B733 : B737Model,
-                   const.AIRCRAFT_B734 : B737Model,
-                   const.AIRCRAFT_B735 : B737Model,
-                   const.AIRCRAFT_DH8D : DH8DModel,
-                   const.AIRCRAFT_B762 : B767Model,
-                   const.AIRCRAFT_B763 : B767Model,
-                   const.AIRCRAFT_CRJ2 : B767Model,
-                   const.AIRCRAFT_F70  : F70Model,
-                   const.AIRCRAFT_DC3  : DC3Model,
-                   const.AIRCRAFT_T134 : T134Model,
-                   const.AIRCRAFT_T154 : T154Model,
-                   const.AIRCRAFT_YK40 : YK40Model }
+_genericModels = { const.AIRCRAFT_B736  : B737Model,
+                   const.AIRCRAFT_B737  : B737Model,
+                   const.AIRCRAFT_B738  : B737Model,
+                   const.AIRCRAFT_B738C : B737Model,
+                   const.AIRCRAFT_B733  : B737Model,
+                   const.AIRCRAFT_B734  : B737Model,
+                   const.AIRCRAFT_B735  : B737Model,
+                   const.AIRCRAFT_DH8D  : DH8DModel,
+                   const.AIRCRAFT_B762  : B767Model,
+                   const.AIRCRAFT_B763  : B767Model,
+                   const.AIRCRAFT_CRJ2  : B767Model,
+                   const.AIRCRAFT_F70   : F70Model,
+                   const.AIRCRAFT_DC3   : DC3Model,
+                   const.AIRCRAFT_T134  : T134Model,
+                   const.AIRCRAFT_T154  : T154Model,
+                   const.AIRCRAFT_YK40  : YK40Model }
 
 #------------------------------------------------------------------------------
Index: src/mlx/gui/common.py
===================================================================
--- src/mlx/gui/common.py	(revision 175)
+++ src/mlx/gui/common.py	(revision 191)
@@ -201,19 +201,20 @@
 
 # A mapping of aircraft types to their screen names
-aircraftNames = { _const.AIRCRAFT_B736 : xstr("aircraft_b736"),
-                  _const.AIRCRAFT_B737 : xstr("aircraft_b737"),
-                  _const.AIRCRAFT_B738 : xstr("aircraft_b738"),
-                  _const.AIRCRAFT_B733 : xstr("aircraft_b733"),
-                  _const.AIRCRAFT_B734 : xstr("aircraft_b734"),
-                  _const.AIRCRAFT_B735 : xstr("aircraft_b735"),
-                  _const.AIRCRAFT_DH8D : xstr("aircraft_dh8d"),
-                  _const.AIRCRAFT_B762 : xstr("aircraft_b762"),
-                  _const.AIRCRAFT_B763 : xstr("aircraft_b763"),
-                  _const.AIRCRAFT_CRJ2 : xstr("aircraft_crj2"),
-                  _const.AIRCRAFT_F70  : xstr("aircraft_f70"),
-                  _const.AIRCRAFT_DC3  : xstr("aircraft_dc3"),
-                  _const.AIRCRAFT_T134 : xstr("aircraft_t134"),
-                  _const.AIRCRAFT_T154 : xstr("aircraft_t154"),
-                  _const.AIRCRAFT_YK40 : xstr("aircraft_yk40") }
-
-#------------------------------------------------------------------------------
+aircraftNames = { _const.AIRCRAFT_B736  : xstr("aircraft_b736"),
+                  _const.AIRCRAFT_B737  : xstr("aircraft_b737"),
+                  _const.AIRCRAFT_B738  : xstr("aircraft_b738"),
+                  _const.AIRCRAFT_B738C : xstr("aircraft_b738c"),
+                  _const.AIRCRAFT_B733  : xstr("aircraft_b733"),
+                  _const.AIRCRAFT_B734  : xstr("aircraft_b734"),
+                  _const.AIRCRAFT_B735  : xstr("aircraft_b735"),
+                  _const.AIRCRAFT_DH8D  : xstr("aircraft_dh8d"),
+                  _const.AIRCRAFT_B762  : xstr("aircraft_b762"),
+                  _const.AIRCRAFT_B763  : xstr("aircraft_b763"),
+                  _const.AIRCRAFT_CRJ2  : xstr("aircraft_crj2"),
+                  _const.AIRCRAFT_F70   : xstr("aircraft_f70"),
+                  _const.AIRCRAFT_DC3   : xstr("aircraft_dc3"),
+                  _const.AIRCRAFT_T134  : xstr("aircraft_t134"),
+                  _const.AIRCRAFT_T154  : xstr("aircraft_t154"),
+                  _const.AIRCRAFT_YK40  : xstr("aircraft_yk40") }
+
+#------------------------------------------------------------------------------
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 184)
+++ src/mlx/gui/flight.py	(revision 191)
@@ -15,22 +15,4 @@
 import datetime
 import time
-
-#------------------------------------------------------------------------------
-
-acftTypeNames = { const.AIRCRAFT_B736: "Boeing 737-600",
-                  const.AIRCRAFT_B737: "Boeing 737-700",
-                  const.AIRCRAFT_B738: "Boeing 737-800",
-                  const.AIRCRAFT_DH8D: "Bombardier Dash 8-Q400",
-                  const.AIRCRAFT_B733: "Boeing 737-300",
-                  const.AIRCRAFT_B734: "Boeing 737-400",
-                  const.AIRCRAFT_B735: "Boeing 737-500",
-                  const.AIRCRAFT_B762: "Boeing 767-200",
-                  const.AIRCRAFT_B763: "Boeing 767-300",
-                  const.AIRCRAFT_CRJ2: "Bombardier CRJ200",
-                  const.AIRCRAFT_F70:  "Fokker 70",
-                  const.AIRCRAFT_DC3:  "Lisunov Li-2",
-                  const.AIRCRAFT_T134: "Tupolev Tu-134",
-                  const.AIRCRAFT_T154: "Tupolev Tu-154",
-                  const.AIRCRAFT_YK40: "Yakovlev Yak-40" }
 
 #-----------------------------------------------------------------------------
@@ -688,5 +670,5 @@
         labelAlignment = gtk.Alignment(xalign=0.0, xscale=0.0)
         self._flightNumber = gtk.Label()
-        self._flightNumber.set_width_chars(7)
+        self._flightNumber.set_width_chars(9)
         self._flightNumber.set_alignment(0.0, 0.5)
         labelAlignment.add(self._flightNumber)
@@ -759,5 +741,5 @@
         self._flightNumber.set_markup("<b>" + bookedFlight.callsign + "</b>")
 
-        aircraftType = acftTypeNames[bookedFlight.aircraftType]
+        aircraftType = aircraftNames[bookedFlight.aircraftType]
         self._aircraft.set_markup("<b>" + aircraftType + "</b>")
         
Index: src/mlx/i18n.py
===================================================================
--- src/mlx/i18n.py	(revision 190)
+++ src/mlx/i18n.py	(revision 191)
@@ -132,19 +132,20 @@
     def initialize(self):
         """Initialize the strings."""
-        self.add("aircraft_b736", "Boeing 737-600")
-        self.add("aircraft_b737", "Boeing 737-700")
-        self.add("aircraft_b738", "Boeing 737-800")
-        self.add("aircraft_b733", "Boeing 737-300")
-        self.add("aircraft_b734", "Boeing 737-400")
-        self.add("aircraft_b735", "Boeing 737-500")
-        self.add("aircraft_dh8d", "Bombardier Dash 8 Q400")
-        self.add("aircraft_b762", "Boeing 767-200")
-        self.add("aircraft_b763", "Boeing 767-300")
-        self.add("aircraft_crj2", "Canadair Regional Jet CRJ-200")
-        self.add("aircraft_f70",  "Fokker F70")
-        self.add("aircraft_dc3",  "Lisunov Li-2")
-        self.add("aircraft_t134", "Tupolev Tu-134")
-        self.add("aircraft_t154", "Tupolev Tu-154")
-        self.add("aircraft_yk40", "Yakovlev Yak-40")
+        self.add("aircraft_b736",  "Boeing 737-600")
+        self.add("aircraft_b737",  "Boeing 737-700")
+        self.add("aircraft_b738",  "Boeing 737-800")
+        self.add("aircraft_b738c", "Boeing 737-800 (charter)")
+        self.add("aircraft_b733",  "Boeing 737-300")
+        self.add("aircraft_b734",  "Boeing 737-400")
+        self.add("aircraft_b735",  "Boeing 737-500")
+        self.add("aircraft_dh8d",  "Bombardier Dash 8 Q400")
+        self.add("aircraft_b762",  "Boeing 767-200")
+        self.add("aircraft_b763",  "Boeing 767-300")
+        self.add("aircraft_crj2",  "Canadair Regional Jet CRJ-200")
+        self.add("aircraft_f70",   "Fokker F70")
+        self.add("aircraft_dc3",   "Lisunov Li-2")
+        self.add("aircraft_t134",  "Tupolev Tu-134")
+        self.add("aircraft_t154",  "Tupolev Tu-154")
+        self.add("aircraft_yk40",  "Yakovlev Yak-40")
 
         self.add("file_filter_all", "All files")
@@ -829,19 +830,20 @@
     def initialize(self):
         """Initialize the strings."""
-        self.add("aircraft_b736", "Boeing 737-600")
-        self.add("aircraft_b737", "Boeing 737-700")
-        self.add("aircraft_b738", "Boeing 737-800")
-        self.add("aircraft_b733", "Boeing 737-300")
-        self.add("aircraft_b734", "Boeing 737-400")
-        self.add("aircraft_b735", "Boeing 737-500")
-        self.add("aircraft_dh8d", "Bombardier Dash 8 Q400")
-        self.add("aircraft_b762", "Boeing 767-200")
-        self.add("aircraft_b763", "Boeing 767-300")
-        self.add("aircraft_crj2", "Canadair Regional Jet CRJ-200")
-        self.add("aircraft_f70",  "Fokker F70")
-        self.add("aircraft_dc3",  "Liszunov Li-2")
-        self.add("aircraft_t134", "Tupoljev Tu-134")
-        self.add("aircraft_t154", "Tupoljev Tu-154")
-        self.add("aircraft_yk40", "Jakovlev Jak-40")
+        self.add("aircraft_b736",  "Boeing 737-600")
+        self.add("aircraft_b737",  "Boeing 737-700")
+        self.add("aircraft_b738",  "Boeing 737-800")
+        self.add("aircraft_b738c", "Boeing 737-800 (charter)")
+        self.add("aircraft_b733",  "Boeing 737-300")
+        self.add("aircraft_b734",  "Boeing 737-400")
+        self.add("aircraft_b735",  "Boeing 737-500")
+        self.add("aircraft_dh8d",  "Bombardier Dash 8 Q400")
+        self.add("aircraft_b762",  "Boeing 767-200")
+        self.add("aircraft_b763",  "Boeing 767-300")
+        self.add("aircraft_crj2",  "Canadair Regional Jet CRJ-200")
+        self.add("aircraft_f70",   "Fokker F70")
+        self.add("aircraft_dc3",   "Liszunov Li-2")
+        self.add("aircraft_t134",  "Tupoljev Tu-134")
+        self.add("aircraft_t154",  "Tupoljev Tu-154")
+        self.add("aircraft_yk40",  "Jakovlev Jak-40")
 
         self.add("file_filter_all", "Összes fájl")
Index: src/mlx/soundsched.py
===================================================================
--- src/mlx/soundsched.py	(revision 176)
+++ src/mlx/soundsched.py	(revision 191)
@@ -120,11 +120,12 @@
     played."""
 
-    _sounds = { const.AIRCRAFT_B736 : const.SOUND_TAXI_BOEING737NG,
-                const.AIRCRAFT_B737 : const.SOUND_TAXI_BOEING737NG,
-                const.AIRCRAFT_B738 : const.SOUND_TAXI_BOEING737NG,
-                const.AIRCRAFT_B762 : const.SOUND_TAXI_BOEING767,
-                const.AIRCRAFT_B763 : const.SOUND_TAXI_BOEING767,
-                const.AIRCRAFT_F70  : const.SOUND_TAXI_F70 }
-                    
+    _sounds = { const.AIRCRAFT_B736  : const.SOUND_TAXI_BOEING737NG,
+                const.AIRCRAFT_B737  : const.SOUND_TAXI_BOEING737NG,
+                const.AIRCRAFT_B738  : const.SOUND_TAXI_BOEING737NG,
+                const.AIRCRAFT_B738C : const.SOUND_TAXI_BOEING737NG,
+                const.AIRCRAFT_B762  : const.SOUND_TAXI_BOEING767,
+                const.AIRCRAFT_B763  : const.SOUND_TAXI_BOEING767,
+                const.AIRCRAFT_F70   : const.SOUND_TAXI_F70 }
+
     def __init__(self, flight, boardingSound = None):
         """Construct the taxi sound."""
Index: src/mlx/web.py
===================================================================
--- src/mlx/web.py	(revision 188)
+++ src/mlx/web.py	(revision 191)
@@ -34,35 +34,37 @@
 class BookedFlight(object):
     """A flight that was booked."""
-    TYPECODE2TYPE = { "736" : const.AIRCRAFT_B736,
-                      "73G" : const.AIRCRAFT_B737,
-                      "738" : const.AIRCRAFT_B738,
-                      "733" : const.AIRCRAFT_B733,
-                      "734" : const.AIRCRAFT_B734,
-                      "735" : const.AIRCRAFT_B735,
-                      "DH4" : const.AIRCRAFT_DH8D,
-                      "762" : const.AIRCRAFT_B762,
-                      "763" : const.AIRCRAFT_B763,
-                      "CR2" : const.AIRCRAFT_CRJ2,
-                      "F70" : const.AIRCRAFT_F70,
-                      "LI2" : const.AIRCRAFT_DC3,
-                      "TU3" : const.AIRCRAFT_T134,
-                      "TU5" : const.AIRCRAFT_T154,
-                      "YK4" : const.AIRCRAFT_YK40 }
-
-    TYPE2TYPECODE = { const.AIRCRAFT_B736 : "736",
-                      const.AIRCRAFT_B737 : "73G",
-                      const.AIRCRAFT_B738 : "738",
-                      const.AIRCRAFT_B733 : "733",
-                      const.AIRCRAFT_B734 : "734",
-                      const.AIRCRAFT_B735 : "735",
-                      const.AIRCRAFT_DH8D : "DH4",
-                      const.AIRCRAFT_B762 : "762",
-                      const.AIRCRAFT_B763 : "763",
-                      const.AIRCRAFT_CRJ2 : "CR2",
-                      const.AIRCRAFT_F70  : "F70",
-                      const.AIRCRAFT_DC3  : "LI2",
-                      const.AIRCRAFT_T134 : "TU3",
-                      const.AIRCRAFT_T154 : "TU5",
-                      const.AIRCRAFT_YK40 : "YK4" }
+    TYPECODE2TYPE = { "736"  : const.AIRCRAFT_B736,
+                      "73G"  : const.AIRCRAFT_B737,
+                      "738"  : const.AIRCRAFT_B738,
+                      "73H"  : const.AIRCRAFT_B738C,
+                      "733"  : const.AIRCRAFT_B733,
+                      "734"  : const.AIRCRAFT_B734,
+                      "735"  : const.AIRCRAFT_B735,
+                      "DH4"  : const.AIRCRAFT_DH8D,
+                      "762"  : const.AIRCRAFT_B762,
+                      "763"  : const.AIRCRAFT_B763,
+                      "CR2"  : const.AIRCRAFT_CRJ2,
+                      "F70"  : const.AIRCRAFT_F70,
+                      "LI2"  : const.AIRCRAFT_DC3,
+                      "TU3"  : const.AIRCRAFT_T134,
+                      "TU5"  : const.AIRCRAFT_T154,
+                      "YK4"  : const.AIRCRAFT_YK40 }
+
+    TYPE2TYPECODE = { const.AIRCRAFT_B736  : "736",
+                      const.AIRCRAFT_B737  : "73G",
+                      const.AIRCRAFT_B738  : "738",
+                      const.AIRCRAFT_B738C : "73H",
+                      const.AIRCRAFT_B733  : "733",
+                      const.AIRCRAFT_B734  : "734",
+                      const.AIRCRAFT_B735  : "735",
+                      const.AIRCRAFT_DH8D  : "DH4",
+                      const.AIRCRAFT_B762  : "762",
+                      const.AIRCRAFT_B763  : "763",
+                      const.AIRCRAFT_CRJ2  : "CR2",
+                      const.AIRCRAFT_F70   : "F70",
+                      const.AIRCRAFT_DC3   : "LI2",
+                      const.AIRCRAFT_T134  : "TU3",
+                      const.AIRCRAFT_T154  : "TU5",
+                      const.AIRCRAFT_YK40  : "YK4" }
 
     @staticmethod