Index: src/mlx/acft.py
===================================================================
--- src/mlx/acft.py	(revision 210)
+++ src/mlx/acft.py	(revision 211)
@@ -73,8 +73,5 @@
         self._checkers.append(checks.SquawkLogger())
 
-        self._checkers.append(checks.AnticollisionLightsLogger())
-        self._checkers.append(checks.LandingLightsLogger())
-        self._checkers.append(checks.StrobeLightsLogger())
-        self._checkers.append(checks.NavLightsLogger())
+        self._appendLightsLoggers()
 
         self._checkers.append(checks.FlapsLogger())
@@ -96,9 +93,6 @@
 
         # Fault checkers
-        
-        self._checkers.append(checks.AntiCollisionLightsChecker())
-        self._checkers.append(checks.LandingLightsChecker())
-        self._checkers.append(checks.NavLightsChecker())
-        self._checkers.append(checks.StrobeLightsChecker())
+
+        self._appendLightsCheckers()
 
         self._checkers.append(checks.BankChecker())
@@ -314,4 +308,24 @@
             self._logV1R2()
 
+    def _appendLightsLoggers(self):
+        """Append the loggers needed for the lights.
+
+        This default implementation adds the loggers for the anti-collision
+        lights, the landing lights, the strobe lights and the NAV lights."""
+        self._checkers.append(checks.AnticollisionLightsLogger())
+        self._checkers.append(checks.LandingLightsLogger())
+        self._checkers.append(checks.StrobeLightsLogger())
+        self._checkers.append(checks.NavLightsLogger())
+
+    def _appendLightsCheckers(self):
+        """Append the checkers needed for the lights.
+
+        This default implementation adds the checkers for the anti-collision
+        lights, the landing lights, the strobe lights and the NAV lights."""
+        self._checkers.append(checks.AntiCollisionLightsChecker())
+        self._checkers.append(checks.LandingLightsChecker())
+        self._checkers.append(checks.NavLightsChecker())
+        self._checkers.append(checks.StrobeLightsChecker())
+
     def _logV1R2(self):
         """Log the V1, Vr and V2 value either newly, or by updating the
@@ -706,4 +720,16 @@
                             "Total fuel: %.0f kg" % (sum(aircraftState.fuel),))
                             
+    def _appendLightsLoggers(self):
+        """Append the loggers needed for the lights."""
+        self._checkers.append(checks.AnticollisionLightsLogger())
+        self._checkers.append(checks.LandingLightsLogger())
+        self._checkers.append(checks.NavLightsLogger())
+
+    def _appendLightsCheckers(self):
+        """Append the checkers needed for the lights."""
+        self._checkers.append(checks.TupolevAntiCollisionLightsChecker())
+        self._checkers.append(checks.LandingLightsChecker())
+        self._checkers.append(checks.NavLightsChecker())
+
 #---------------------------------------------------------------------------------------
 
@@ -741,4 +767,16 @@
                             "Total fuel: %.0f kg" % (sum(aircraftState.fuel),))
 
+    def _appendLightsLoggers(self):
+        """Append the loggers needed for the lights."""
+        self._checkers.append(checks.AnticollisionLightsLogger())
+        self._checkers.append(checks.LandingLightsLogger())
+        self._checkers.append(checks.NavLightsLogger())
+
+    def _appendLightsCheckers(self):
+        """Append the checkers needed for the lights."""
+        self._checkers.append(checks.TupolevAntiCollisionLightsChecker())
+        self._checkers.append(checks.LandingLightsChecker())
+        self._checkers.append(checks.NavLightsChecker())
+
 #---------------------------------------------------------------------------------------
 
@@ -772,4 +810,16 @@
         self.logger.message(aircraftState.timestamp,
                             "Total fuel: %.0f kg" % (sum(aircraftState.fuel),))
+
+    def _appendLightsLoggers(self):
+        """Append the loggers needed for the lights."""
+        self._checkers.append(checks.AnticollisionLightsLogger())
+        self._checkers.append(checks.LandingLightsLogger())
+        self._checkers.append(checks.NavLightsLogger())
+
+    def _appendLightsCheckers(self):
+        """Append the checkers needed for the lights."""
+        self._checkers.append(checks.AntiCollisionLightsChecker())
+        self._checkers.append(checks.LandingLightsChecker())
+        self._checkers.append(checks.NavLightsChecker())
 
 #---------------------------------------------------------------------------------------